export const set = (key, val) => 
    new Promise((resolve, reject) => {
        document.cookie = `${key}=${val}`;
        resolve(true);
    });


export const get = key =>
    new Promise((resolve, reject) => {
        const match = document.cookie.match(new RegExp(`(${key})=(.*?);`));
        resolve(match ? match[2] : null);
    });

export const getAll = () =>
    new Promise((resolve, reject) => {
        const cookies = {};
        document.cookie.split(';').map(cookie => cookie.split('=')).forEach(([key, val]) => cookies[key] = val);
        resolve(cookies);
    });


export const remove = key =>
    new Promise((resolve, reject) => {
        document.cookie = `${key}=; expires=Thu, 01 Jan 1970 00:00:01 GMT;`;
        resolve(true);
    });

export const clear = () =>
    new Promise((resolve, reject) => {
        document.cookie.split(';').map(cookie => cookie.split('=')[0]).forEach(remove);
        resolve(true);
    });
